<?php
/*
Plugin Name: Game Timer
Plugin URI: http://samrat131.wordpress.com/
Description: Game timer with email notification and music alert
Version: 1.0
Author: samrat131
Author URI: http://samrat131.wordpress.com/
License: GPL2
*/


$pluginsUrl = WP_PLUGIN_URL.'/game-timer/';
$pluginsURI = get_option('siteurl').'/wp-content/plugins/'.dirname(plugin_basename(__FILE__)); 
$pluginsAdminURI = get_option('siteurl').'/wp-admin/admin.php?page=wpgt_add_games';

//date_default_timezone_set('US/Central');
//echo date("F j, Y, g:i a",current_time('timestamp'));

add_action('admin_print_scripts', 'wpgt_do_jslibs' );
add_action('admin_print_styles', 'wpgt_do_css' );

function register_wpgt_email_template() {
	//register our settings
	register_setting( 'wpgt-settings-group-email-template', 'wpgt_email_template' );
	register_setting( 'wpgt-settings-group-email-template', 'wpgt_email_template_subject' );
}


function wpgt_do_css()
{
    wp_enqueue_style('thickbox');
}

function wpgt_do_jslibs()
{
    wp_enqueue_script('editor');
    wp_enqueue_script('thickbox');
	wp_enqueue_script('media-upload');
    add_action( 'admin_head', 'wp_tiny_mce' );
}


function wpgt_my_script() {
	global $pluginsURI;
	
	//wp_deregister_script('jquery');
	//wp_register_script('jquery', $pluginURI .'/jquery-1.7.min.js', false, '1.7');
	wp_enqueue_script('jquery');
	
	wp_register_script('jquery_countdown', $pluginsURI.'/jquery.countdown.js', array(), '1.5.11');
	wp_enqueue_script('jquery_countdown');
	
	wp_register_script('jwplayer', $pluginsURI.'/jwplayer.js', array(), '5.8');
	wp_enqueue_script('jwplayer');
	
	wp_register_style('jquery_countdown_css', $pluginsURI . '/jquery.countdown.css', array(), '1.5.11' );
	wp_enqueue_style( 'jquery_countdown_css' );	
	
}

function wpgt_jQuery_files() {
	echo '';
}


add_action('init', 'wpgt_my_script');
add_action('wp_head', 'wpgt_jQuery_files');

/*if ( isset($_POST['edit_game_timer_list']) and is_numeric($_POST['id']) ) {
	//print_r($_REQUEST);
	global $wpdb;
	$table_servers = $wpdb->prefix . "game_timer_list";
}*/

if (isset($_POST['user_id']) and is_numeric($_POST['user_id']) and $_POST['user_id'] > 0) {

	
	//echo getcwd();
	//exit;
	global $wpdb;
	//global $user;
	
	if( $_POST['add_games_i_play'] != '' ){
	
		//print_r($_POST);
	
		$table_games = $wpdb->prefix . "game_timer";
		$res = $wpdb->insert( $table_games, array( 
		'user_id'=>$_POST['user_id'],
		'game_name'=>htmlentities($_POST['add_games_i_play']), 
		'game_url'=>'', 
		'created_at'=> current_time('timestamp'),
		'active'=>'1'
		));
	}
	
	if($res)
		$_POST['games_i_play'] = mysql_insert_id();
	//exit;
	
	$table_servers = $wpdb->prefix . "game_timer_list";
	if ($_POST['games_i_play'] != '' and is_numeric($_POST['games_i_play'])){
		//print_r($_POST);
		//if ( isset($_POST['email_notification']) )
		//$email_notification = ($_POST['email_notification'])?$_POST['email_notification']:0;
		
		$timer = 0;
		if($_POST['days'] !='' and is_numeric($_POST['days']) ){
			$timer = $_POST['days'] * 24 * 60 * 60;
		
		}
		
		if($_POST['hours'] !='' and is_numeric($_POST['hours']) ){	
			$timer += $_POST['hours'] * 60 * 60;
		}	
		
		if($_POST['minutes'] !='' and is_numeric($_POST['minutes']) ){	
			$timer += $_POST['minutes'] * 60;
		}
		$ctime = current_time('timestamp');
		$msg = "";
		
		if ( isset($_POST['edit_game_timer_list']) and is_numeric($_POST['id']) ) {
		
			$res = $wpdb->update( $table_servers, array( 
			'games_i_play'=>$_POST['games_i_play'], 
			'description'=> $_POST['description'], 
			'music_id'=>$_POST['music_id'], 
			'timer'=> $timer,
			'timer_create'=> $ctime,
			'timer_cron'=>($timer+$ctime),
			'user_id'=>$_POST['user_id'],
			'user_email'=>$_POST['user_email'],
			'email_notification'=>$_POST['email_notification'],
			),
			array('id'=>$_POST['id'])
			);
			
			$weburl = 'http://'. $_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI'];
			$weburl = parse_url($weburl);
			$weburl =  $weburl['path'];
			//echo $weburl;
			
			if($res) {
				$msg = "Update successfully!!!";
			} else {
				$msg = "Update fail!";
			}
			header ( 'Location: '.$weburl );
			exit;
			//wp_redirect( $weburl ); 
		}
		else	
		{
			//$msg = "";
			//$ctime = current_time('timestamp');
			$res = $wpdb->insert( $table_servers, array( 
			'games_i_play'=>$_POST['games_i_play'], 
			'description'=> $_POST['description'], 
			'music_id'=>$_POST['music_id'], 
			'timer'=> $timer,
			'timer_create'=> $ctime,
			'timer_cron'=>$timer+$ctime,
			'user_id'=>$_POST['user_id'],
			'user_email'=>$_POST['user_email'],
			'email_notification'=>$_POST['email_notification'],
			));
			
			if($res) {
				$msg = "Insert successfully!!!";
				//include("wp-config.php");
				require_once(ABSPATH . 'wp-includes/pluggable.php');
				update_user_meta( $_POST['user_id'], 'wpgt_games_i_play', $_POST['games_i_play'] );
				update_user_meta( $_POST['user_id'], 'wpgt_description', $_POST['description'] );
				update_user_meta( $_POST['user_id'], 'wpgt_music_id', $_POST['music_id'] );
				update_user_meta( $_POST['user_id'], 'wpgt_email_notification', $_POST['email_notification'] );
				
			} else {
				$msg = "Insert fail!";
			}
		}
	}
}

function wpgt_delete_data($id,$tablename){
	global $wpdb;
	if(!is_numeric($id) and $tablename=='')
	return;

	$delete = "DELETE FROM ".$tablename." WHERE id = $id LIMIT 1";
	//echo $delete;
	$results = $wpdb->query($delete);
	if($results)
		return "Delete Successfully!!!"."<br />";
	else
		return "Delete Fail!"."<br />";
}

if ( isset($_GET['delete']) and $_GET['delete']=='y' ) {
	if ($_REQUEST['id'] != '')
	{
		$table_name = $wpdb->prefix . $_REQUEST['table'];
		if($_REQUEST['table'] == 'game_timer_music'){
			$sql = "SELECT * FROM ".$table_name." WHERE id=".$_GET['id']." LIMIT 0,1";
			$vdoinfo = $wpdb->get_row($sql);
			$music_file_path = "../wp-content/uploads/";
			if (!empty($vdoinfo))
			{
				@unlink($music_file_path.$vdoinfo->url);
			}
		}
		$msg = wpgt_delete_data($_GET['id'],$table_name);
	}
}

function wpgt_db_install () {
	global $wpdb;
	$table_name = $wpdb->prefix . "game_timer";
	if($wpdb->get_var("show tables like '$table_name'") != $table_name) {
	$sql = "CREATE TABLE IF NOT EXISTS `$table_name` (
  `id` bigint(20) NOT NULL AUTO_INCREMENT,
  `user_id` int(11),
  `game_name` varchar(255) DEFAULT NULL,
  `game_url` varchar(255) DEFAULT NULL,
  `created_at` varchar(50) DEFAULT NULL,
  `active` varchar(50) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;
";
	require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
	dbDelta($sql);
	}
	
	$table_name = $wpdb->prefix . "game_timer_list";
	if($wpdb->get_var("show tables like '$table_name'") != $table_name) {
	$sql = "CREATE TABLE IF NOT EXISTS `$table_name` (
  `id` bigint(20) NOT NULL AUTO_INCREMENT,
  `games_i_play` int(11) NOT NULL,
  `description` text,
  `music_id` int(11) NOT NULL,
  `timer` bigint(20) DEFAULT NULL,
  `timer_create` bigint(20) NOT NULL,
  `timer_cron` bigint(20) NOT NULL,
  `user_id` int(11) NOT NULL,
  `user_email` varchar(255) DEFAULT NULL,
  `email_notification` tinyint(4) NOT NULL,
  `email_sent` tinyint(4) DEFAULT 0,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;
";
	require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
	dbDelta($sql);
	}
	
	$table_name = $wpdb->prefix . "game_timer_music";
	if($wpdb->get_var("show tables like '$table_name'") != $table_name) {
	$sql = "CREATE TABLE IF NOT EXISTS `$table_name` (
  `id` bigint(20) NOT NULL AUTO_INCREMENT,
  `title` varchar(255) DEFAULT NULL,
  `url` varchar(255) DEFAULT NULL,
  `created_at` varchar(50) DEFAULT NULL,
  `active` tinyint(4) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=1;";

	require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
	dbDelta($sql);
	}
	
	
	
}
register_activation_hook(__FILE__,'wpgt_db_install');

function wpgt_deactivate() {
	global $wpdb;
	$table_name = $wpdb->prefix . "game_timer";
	$sql = "DROP TABLE `$table_name`;";
	$wpdb->query($sql);
	
	$table_name = $wpdb->prefix . "game_timer_list";
	$sql = "DROP TABLE `$table_name`;";
	$wpdb->query($sql);
	
	$table_name = $wpdb->prefix . "game_timer_music";
	$sql = "DROP TABLE `$table_name`;";
	$wpdb->query($sql);
	
}

register_deactivation_hook(__FILE__, 'wpgt_deactivate' );


function wpgt_add_pages() {
	add_menu_page('Timer', 'Game Timer', 'manage_options', 'wpgt_page', 'wpgt_view_user_fn' );
	
	add_submenu_page('wpgt_page', 'Add games I play', 'Add games I play', 'manage_options', 'wpgt_add_games', 'wpgt_add_games_fn');
	add_submenu_page('wpgt_page', 'Add music', 'Add music', 'manage_options', 'wpgt_add_music', 'wpgt_add_music_fn');
	add_submenu_page('wpgt_page', 'Email template', 'Email template', 'manage_options', 'wpgt_email_template', 'wpgt_email_template_fn');
	
	add_action( 'admin_init', 'register_wpgt_email_template' );

}
add_action('admin_menu', 'wpgt_add_pages');

if ( isset($_POST['wpgt_delete_game_id']) and $_POST['wpgt_delete_game_id'] == 'yes'){
	$msg = wpgt_delete_data($_POST['wpgt_game_id'], $wpdb->prefix.'game_timer_list');
}	

if ( isset($_POST['wpgt_delete_all_game_id']) and $_POST['wpgt_delete_all_game_id'] == 'yes'){

	$table_name = $wpdb->prefix.'game_timer_list';
	$select = "SELECT id from $table_name where timer_cron<=".current_time('timestamp')." and user_id=".$_POST['user_id'];
	//echo $select; 
	$data = $wpdb->get_results($select);
	//print_r($data);
	foreach($data as $gdata)
	$msg .= wpgt_delete_data($gdata->id, $wpdb->prefix.'game_timer_list').'<br />';
}	

if ( isset($_POST['wpgt_game_submit']) and $_POST['wpgt_game_submit'] == 'yes'){
	
	global $wpdb;
	$table_servers = $wpdb->prefix . "game_timer";
	if ($_POST['mode'] == 'addnew'){
		//print_r($_POST);
		$msg = "";
		$res = $wpdb->insert( $table_servers, array( 
		'game_name'=>htmlentities($_POST['game_name']), 
		'game_url'=>htmlentities($_POST['game_url']), 
		'created_at'=> current_time('timestamp'),
		'active'=>'1'
		));
		
		if($res) {
			$msg = "Insert successfully!!!";
		} else {
			$msg = "Insert fail!";
		}
	}
	if ($_POST['mode'] == 'edit'){
		$res = $wpdb->update( $table_servers, array(
		'game_name'=>htmlentities($_POST['game_name']),
		'game_url'=>htmlentities($_POST['game_url']),
		'created_at'=> current_time('timestamp')
		), array( 'id' => $_POST['id'] ) );
		if($res) {
			$msg = "Update successfully!!!";
		} else {
			$msg = "Update fail!";
		}
	}
}

if ( isset($_POST['wpgt_music_submit']) and $_POST['wpgt_music_submit'] == 'yes'){
	
	global $wpdb;
	$table_servers = $wpdb->prefix . "game_timer_music";
	if ($_POST['mode'] == 'addnew'){
		//print_r($_POST);
		
		$music_file_path = "../wp-content/uploads/";
			$type= 1;
			if ($_FILES["music_file"]["name"] != "" and $_FILES["music_file"]["error"] == 0 ){
			
				$ext = pathinfo($_FILES["music_file"]["name"]);
				//print_r($ext);exit;
				if( ($ext['extension'] == 'mp3') && ($_FILES["music_file"]["size"] < 1024*1024*5) )
				  {
					$music_file_name = current_time('timestamp').'_'.$_FILES["music_file"]["name"];
					$music_file_name = str_replace(' ','_',$music_file_name);
					$music_file_name = str_replace('-','_',$music_file_name);
					$fstatus = move_uploaded_file($_FILES["music_file"]["tmp_name"], $music_file_path . $music_file_name);
					if ($fstatus == true){
						$msg = "File Uploaded Successfully!!!"."<br />";
					}
				  }
				else
				{
					$err .= "Invalid file type or max file size exceded" . "<br />";
				}
			}
			else
			{
				$err .= "Please input image file". "<br />";
			}// end if image file
		
		$msg = "";
		$res = $wpdb->insert( $table_servers, array( 
		'title'=>htmlentities($_POST['title']), 
		'url'=> $music_file_name,
		'created_at'=> current_time('timestamp'),
		'active'=>'1'
		));
		
		if($res) {
			$msg = "Insert successfully!!!";
		} else {
			$msg = "Insert fail!";
		}
	}
	if ($_POST['mode'] == 'edit'){
		$res = $wpdb->update( $table_servers, array(
		'game_name'=>htmlentities($_POST['game_name']), 
		'created_at'=> current_time('timestamp')
		), array( 'id' => $_POST['id'] ) );
		if($res) {
			$msg = "Update successfully!!!";
		} else {
			$msg = "Update fail!";
		}
	}
}

function wpgt_email_template_fn() {
	include_once('wpgt_email_template_fn.php');
}


function wpgt_view_user_fn() {
	include_once('wpgt_view_user_fn.php');
}

function wpgt_add_games_fn() {
	include_once('wpgt_add_games_fn.php');
}

function wpgt_add_music_fn() {
	include_once('wpgt_add_music_fn.php');
}

function wpgt_game_timer_show() {
	ob_start();
	include_once('wpgt_game_timer_show.php');
	$out= ob_get_contents();
	ob_end_clean();
	return $out;
}

function wpgt_widget_fn() {
	ob_start();
	include_once('wpgt_widget.php');
	$out= ob_get_contents();
	ob_end_clean();
	return $out;
}

class Wpgt_widget extends WP_Widget {
	function __construct() {
		parent::WP_Widget( 'wpgt_widget', 'Game Timer', array( 'description' => 'Game Timer Form' ) );
	}

	function widget( $args, $instance ) {
		extract( $args );
		$title = apply_filters( 'widget_title', $instance['title'] );
		echo $before_widget;
		if ( $title )
			echo $before_title . $title . $after_title; 
		echo wpgt_widget_fn();
		echo $after_widget;
	}

	function update( $new_instance, $old_instance ) {
		$instance = $old_instance;
		$instance['title'] = strip_tags($new_instance['title']);
		return $instance;
	}

	function form( $instance ) {
		if ( $instance ) {
			$title = esc_attr( $instance[ 'title' ] );
		}
		else {
			$title = __( 'New title', 'text_domain' );
		}
		?>
		<p>
		<label for="<?php echo $this->get_field_id('title'); ?>"><?php _e('Title:'); ?></label> 
		<input class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo $title; ?>" />
		</p>
		<?php 
	}

}
add_action( 'widgets_init', create_function( '', 'register_widget("Wpgt_widget");' ) );

add_shortcode ('game-timer', 'wpgt_game_timer_show');

?>